#include <termios.h> 
#define INLINE inline

/*
Vladimir Myslik (xmyslik@cslab.felk.cvut.cz)

Dedicated to fixw32p updates:
http://cs.felk.cvut.cz/~xmyslik/hercules.html

COPYING POLICY: NONE (it's free even to be included in other programs)
GUARANTEE     : NONE (don't blame me for return of your mother from crypt...)
DATE          : Wed Nov 29 02:53:51 MET 1995
Hi out there.

Have you ever had a problem with your 2MB W32p ?
(I mean those shitty things like snow on the screen when moving windows
& mouse trails & dust etc.) 
This little proggy is for adjusting memory timing on your videoboard (just as
dmemtime.exe  and  powermem.exe provided by HERCULES).
It just tells the chipset how to schedule RAS/CAS (DRAM based boards)
to get it working correctly. This program is invoked with parameters {0,1,x}
for RAS,CAS and POWER_MEMORY bits setting (start without parameters to get
help).

INSTALLLING:

as root, compile it:

prompt$ gcc fixw32p.c -o fixw32p

make it SUID root and copy it to some  reasonable directory

prompt$ chmod 4555 fixw32
prompt$ cp fixw32p /usr/X11R6/bin/

then (if you haven't done already) try to find out your correct setting by
running it from xterm. Be prepared to refresh the screen (sometimes it 
looks funny). At last, add it to your fvwm config (because it needs to be
run *every* time you change resolution) and to your xinitrc script.
There are 4 possible combinations (excluding turning off 64bit mem. access and
crippling the 2MB board to 1MB) of setting.


The code isn't pretty, I'm relatively lazy to make it look and behave better.

Sorry for my poor english, it's 2.30 AM and I'm a little bit dead.

P.S. will you please mail me your configuration and if it works?
Something like this:

 Hercules product          : Hercules Dynamite Power VL
 Model number              : D702
 Windows accelerator chip  : ET4000-W32p
 Video BIOS version        : 8.00N-B4a(03/30/94)
 Display memory size       : 2048K DRAM
 RAMDAC type(s)            : SGS-Thomson STG 1702/1703 (PowerPort)
 Bus type                  : VL
 Bus width                 : 32 bits
 Bus memory address        : See manual
 Bus IO address            : See manual
 
 parameters to fixw32p     : 1 0 1

which is mine.


*/





static INLINE void
outb (short port, char val)
{
  ioperm(port, 1, 1);
  __asm__ volatile ("out%B0 %0,%1" : :"a" (val), "d" (port));
}

static INLINE unsigned char
inb (short port)
{
  unsigned int ret;
  ioperm(port, 1, 1);  
  __asm__ volatile ("in%B0 %1,%0" : "=a" (ret) : "d" (port));
  return ret;
}

void ORreg (int address,short int index, char hodnota)
{
  outb (address, index);				    /* set the register number */
  outb (address+1,hodnota | inb(address+1));
}

int GETreg (int address,short int index, char hodnota)
{
  outb (address, index);				    /* set the register number */
  return (inb(address+1) & hodnota);
}


void ANDreg (int address,short int index, char hodnota)
{
  outb (address, index);				    /* set the register number */
  outb (address+1,hodnota & inb(address+1));
}


main (int argc, char *argv [])
{
if (argc==1) {printf("\nA little more advanced fix for Tseng's ET4000/W32p/2MB chipset
based videocards and Xfree 3.1.1 (maybe even later versions)
This program is for adjusting the internal registers in W32P which control
64 bit video memory access (RAS/CAS). Syntax is :

fixw32p <first bit> <second bit> <third bit>

where <bit> may be 0 , 1 , x (don't change this bit's value) in vga's registers. For example :

fixw32p x 1
         ^^^ 
means that only the 2nd bit is to be changed now.
Hercules dynamite power VL 2MB:

fixw32p 1 0 1

Note that the 3rd bit sets 64 bit video memory access (1=ON).
Hardware specification: 
1st: hardware 6th bit (binary 01000000)in reg# 0x34 on port 0x3d4
2nd: hardware 2nd bit (binary 00000100)in reg# 0x37 on port 0x3d4
3rd: hardware 7th bit (binary 10000000)in reg# 0x32 on port 0x3d4
I count bits from 0 to 7 (zero'th to sevent'h ;-)) in byte\n");return(1);}
printf ("Current values are %i %i %i\n",GETreg (0x3d4,0x34,0x40)>>6,GETreg (0x3d4,0x37,0x4)>>2,GETreg (0x3d4,0x32,0x80)>>7);

if (argc>=2)  {
  if (!strcmp(argv[1],"1"))    { ORreg (0x3d4,0x34,0x40);printf("Setting 1st to 1\n");}
  if (!strcmp(argv[1],"0"))    {ANDreg (0x3d4,0x34,0xbf);printf("Setting 1st to 0\n");}
              }
if (argc>=3)  {
  if (!strcmp(argv[2],"1"))    { ORreg (0x3d4,0x37,0x04);printf("Setting 2nd to 1\n");}
  if (!strcmp(argv[2],"0"))    {ANDreg (0x3d4,0x37,0xfb);printf("Setting 2nd to 0\n");}
              } 
if (argc>=4)  { 
  if (!strcmp(argv[3],"1"))    { ORreg (0x3d4,0x32,0x80);printf("Setting 3rd to 1 - Power memory ON - 64 bit access\n");}
  if (!strcmp(argv[3],"0"))    {ANDreg (0x3d4,0x32,0x7f);printf("Setting 3rd to 0 - Power memory OFF - 32 bit access\n");}
              } 
}
